%global maven_version 0.5.0.redhat-1
%global maven_repo_dir %{_javadir}/maven-repo
%global __jar_repack 0

Name: qpid-jms
Version:	0.5.0
Release:	2%{?dist}
License:	ASL 2.0
Summary:	Qpid JMS AMQP 1.0 Java Client
Group:		Development/Libraries
URL:		http://qpid.apache.org/components/jms/index.html
Source0:	apache-qpid-jms-%{maven_version}-bin.tar.gz 
Source1:	qpid-jms-parent-%{version}.redhat-1-scm-sources.zip 
Source2: qpid-jms-discovery-0.5.0.redhat-1.pom
Source3: qpid-jms-docs-0.5.0.redhat-1.pom
Source4: qpid-jms-client-0.5.0.redhat-1.pom
Source5: qpid-jms-parent-0.5.0.redhat-1.pom
Source6: apache-qpid-jms-0.5.0.redhat-1.pom
Source7: qpid-jms-activemq-tests-0.5.0.redhat-1.pom
Source8: qpid-jms-interop-tests-0.5.0.redhat-1.pom
Source9: qpid-jms-examples-0.5.0.redhat-1.pom
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch: 	noarch

%description
Qpid JMS is a complete AMQP 1.0 Java Message Service 1.1 client built using Qpid Proton.

%package client
Summary:        Qpid JMS AMQP 1.0 Java - client
Group:          Development/Java
Requires:       geronimo-jms_1.1_spec-amq >= 1.1.1-5
Requires:       qpid-proton-java >= 0.10
Requires:       slf4j-api-amq >= 1.7.12-3

%description client
Qpid JMS AMQP 1.0 Java Client Library


%package client-maven-repo
Summary:        Qpid JMS AMQP 1.0 Java - maven repo
Group:          Development/Java
Requires:       qpid-jms-client = %{version}-%{release}
Requires:       geronimo-jms_1.1_spec-amq-maven-repo >= 1.1.1-5
Requires:       qpid-proton-java-maven-repo >= 0.10
Requires:       slf4j-api-amq-maven-repo >= 1.7.12-3

%description client-maven-repo
Qpid JMS AMQP 1.0 Java Client Library maven repo

%package client-zip
Summary:        Qpid JMS AMQP 1.0 Java - maven repo
Group:          Development/Java

BuildRequires:  geronimo-jms_1.1_spec-amq >= 1.1.1-5
BuildRequires:  qpid-proton-java >= 0.10
BuildRequires:  slf4j-api-amq >= 1.7.12-3
BuildRequires:  geronimo-jms_1.1_spec-amq-maven-repo >= 1.1.1-5
BuildRequires:  qpid-proton-java-maven-repo >= 0.10
BuildRequires:  slf4j-api-amq-maven-repo >= 1.7.12-3

%description client-zip
Qpid JMS AMQP 1.0 Java Client Library zip file

%package client-examples
Summary:	Qpid JMS AMQP 1.0 Java - examples
Group:		Development/Java

BuildRequires:  zip
Requires:	qpid-jms-client = %{version}-%{release}
Requires:       qpid-jms-client-maven-repo = %{version}-%{release}
Requires:       log4j-amq >= 1.2.17-5
Requires:       log4j-amq-maven-repo >= 1.2.17-5
Requires:       slf4j-log4j-amq >= 1.7.12-3
Requires:       slf4j-log4j-amq-maven-repo >= 1.7.12-3

%description client-examples
Qpid JMS AMQP 1.0 Java Client Examples

%package client-docs
Summary:	Qpid JMS AMQP 1.0 Java - docs
Group:		Development/Java

%description client-docs
Qpid JMS AMQP 1.0 Java Client Docs

%prep
%setup -q -n apache-qpid-jms-%{maven_version}

%build

%install
rm -rf %{buildroot}

function maven_checksums() {
  local FILEPATH=$1
  local DESTFILE=$2
  if [ -z "$DESTFILE" ]; then
    DESTFILE=$FILEPATH
  fi
  md5sum $FILEPATH | cut -d' ' -f1 > $DESTFILE.md5
  sha1sum $FILEPATH | cut -d' ' -f1 > $DESTFILE.sha1
}

function populate_maven_repo() {
  local POMPATH=$1
  local POMDIR=${POMPATH%/*}
  local POMFILE=${POMPATH##*/}
  local JARFILE=${POMFILE%.pom}.jar
  %{__mkdir_p} %{buildroot}%{maven_repo_dir}/$POMDIR
  %{__install} -pm 644 %{_sourcedir}/$POMFILE \
                       %{buildroot}%{maven_repo_dir}/$POMDIR
  maven_checksums %{buildroot}%{maven_repo_dir}/$POMDIR/$POMFILE
  local VERSION=${POMDIR##*/}
  local PARENTDIR=${POMDIR%/*}
  local ARTIFACTID=${PARENTDIR##*/}
  local GROUPPATH=${PARENTDIR%/*}
  local GROUPID=${GROUPPATH//\//.}
  cat > %{buildroot}%{maven_repo_dir}/$PARENTDIR/maven-metadata.xml <<EOF
<metadata>
  <groupId>$GROUPID</groupId>
  <artifactId>$ARTIFACTID</artifactId>
  <versioning>
    <release>$VERSION</release>
    <versions>
      <version>$VERSION</version>
    </versions>
    <lastUpdated>$(date +%%Y%%m%%d%%H%%M%%S)</lastUpdated>
  </versioning>
</metadata>
EOF
  maven_checksums %{buildroot}%{maven_repo_dir}/$PARENTDIR/maven-metadata.xml
  if [ -f %{buildroot}%{_javadir}/%{name}-%{version}/$JARFILE ]; then
    ln -s %{_javadir}/%{name}-%{version}/$JARFILE \
          %{buildroot}%{maven_repo_dir}/$POMDIR/$JARFILE
    maven_checksums %{buildroot}%{_javadir}/%{name}-%{version}/$JARFILE \
      %{buildroot}%{maven_repo_dir}/$POMDIR/$JARFILE
  fi
}

%{__install} -dm 755 %{buildroot}%{_javadir}
%{__install} -dm 755 %{buildroot}%{_javadir}/%{name}-%{version}

#for jar in lib/*.jar; do
#  %{__install} -pm 644 "$jar" %{buildroot}%{_javadir}/%{name}-%{version}
#done

%{__install} -pm 644 lib/qpid-jms*.jar %{buildroot}%{_javadir}/%{name}-%{version}
%{__install} -pm 644 lib/netty*.jar %{buildroot}%{_javadir}/%{name}-%{version}

%{__install} -dm 755 %{buildroot}%{_docdir}/%{name}-%{version}
%{__install} -pm 644 LICENSE %{buildroot}%{_docdir}/%{name}-%{version}
%{__install} -pm 644 NOTICE %{buildroot}%{_docdir}/%{name}-%{version}
%{__install} -pm 644 README.txt %{buildroot}%{_docdir}/%{name}-%{version}

# examples
cp -a examples %{buildroot}%{_docdir}/%{name}-%{version}/examples

# docs
cp -a docs %{buildroot}%{_docdir}/%{name}-%{version}/docs

#zip
cp -a .  %{buildroot}%{_javadir}/apache-qpid-jms-%{maven_version}/


populate_maven_repo org/apache/qpid/qpid-jms-discovery/0.5.0.redhat-1/qpid-jms-discovery-0.5.0.redhat-1.pom
populate_maven_repo org/apache/qpid/qpid-jms-client/0.5.0.redhat-1/qpid-jms-client-0.5.0.redhat-1.pom
populate_maven_repo org/apache/qpid/qpid-jms-parent/0.5.0.redhat-1/qpid-jms-parent-0.5.0.redhat-1.pom

cp -LRp %{maven_repo_dir} %{buildroot}%{_javadir}/apache-qpid-jms-%{maven_version}/
cd %{buildroot}%{_javadir}
zip -r apache-qpid-jms-%{maven_version}-bin.zip apache-qpid-jms-%{maven_version}
rm -fr apache-qpid-jms-%{maven_version}

%clean
rm -rf %{buildroot}

%files client
%defattr(-,root,root,-)
%dir %{_javadir}/%{name}-%{version}
%{_javadir}/%{name}-%{version}/*.jar
%{_docdir}/%{name}-%{version}/LICENSE
%{_docdir}/%{name}-%{version}/NOTICE
%{_docdir}/%{name}-%{version}/README.txt

%files client-maven-repo
%defattr(-,root,root,-)
%{maven_repo_dir}

%files client-examples
%defattr(-,root,root,-)
%{_docdir}/%{name}-%{version}/examples/

%files client-docs
%defattr(-,root,root,-)
%{_docdir}/%{name}-%{version}/docs/

%files client-zip
%defattr(-,root,root,-)
%{_javadir}/apache-qpid-jms-%{maven_version}-bin.zip


%changelog
* Wed Sep  9 2015 Irina Boverman <iboverma@redhat.com> - 0.5.0-2
- Resolved ENTMQCL-15

* Mon Aug 31 2015 Irina Boverman <iboverma@redhat.com> - 0.5.0-1
- Rebased to 0.5.0

* Thu Aug 20 2015 Irina Boverman <iboverma@redhat.com> - 0.4.0-1
- Rebased to 0.4.0

* Tue Jul 21 2015 Irina Boverman <iboverma@redhat.com> - 0.3.0-3
- Updated dependencies

* Tue Jul 21 2015 Irina Boverman <iboverma@redhat.com> - 0.3.0-2
- Corrected dependencies

* Tue Jul 21 2015 Irina Boverman <iboverma@redhat.com> - 0.3.0-1
- Added zip file 
- Updated dependencies
- Rebased to 0.3.0

* Tue May 26 2015 Irina Boverman <iboverma@redhat.com> - 0.2.0-2
- Updated dependencies

* Thu May 21 2015 Irina Boverman <iboverma@redhat.com> - 0.2.0-1
- Rebased to 0.2.0

* Fri May  1 2015 Mike Bonnet <mikeb@redhat.com> - 0.1.0-2
- Add maven-repo subpackage

* Thu Apr 10 2015 Irina Boverman <iboverma@redhat.com> - 0.1.0-1
- Initial creation of wrapper rpm
